[![Build Status](https://travis-ci.org/igorescodro/alkaa.svg?branch=master)](https://travis-ci.org/igorescodro/alkaa)
<a href="https://ktlint.github.io/"><img src="https://img.shields.io/badge/code%20style-%E2%9D%A4-FF4081.svg" alt="ktlint"></a>

# Alkaa

Alkaa (_begin_, _start_ in Finnish) is a simple to-do list project to study the latest components, architecure, tools, and APIs released in Android Platform. The project evolved a lot in the last year and now is available in Google Play! :heart:

<a href='https://play.google.com/store/apps/details?id=com.escodro.alkaa'><img alt='Get it on Google Play' src='https://play.google.com/intl/en_us/badges/images/generic/en_badge_web_generic.png' height=64/></a>

Currently, this project covers the following topics:

#### Android
- [Kotlin](https://kotlinlang.org)
  - [High Order Functions](https://kotlinlang.org/docs/reference/lambdas.html)
  - [Extensions](https://kotlinlang.org/docs/reference/extensions.html#extensions)
- [Android Architecture Components](https://developer.android.com/topic/libraries/architecture/)
  - [LiveData](https://developer.android.com/topic/libraries/architecture/livedata)
  - [ViewModel](https://developer.android.com/topic/libraries/architecture/viewmodel)
  - [Room](https://developer.android.com/topic/libraries/architecture/room)
  - [Lifecycle](https://developer.android.com/topic/libraries/architecture/lifecycle)
  - [Navigation](https://developer.android.com/topic/libraries/architecture/navigation/)
- [ListAdapter](https://developer.android.com/reference/android/support/v7/recyclerview/extensions/ListAdapter)  
- [Data Binding](https://developer.android.com/topic/libraries/data-binding/)
- [ConstraintLayout](https://developer.android.com/training/constraint-layout/)
- [Android KTX](https://developer.android.com/kotlin/ktx)

#### Third-Party
- [Koin](https://insert-koin.io)
- [RxJava 2 e RxAndroid 2](https://github.com/ReactiveX/RxAndroid)
- [Timber](https://github.com/JakeWharton/timber)

#### Quality check
- [klint](https://github.com/shyiko/ktlint)
- [detekt](https://github.com/arturbosch/detekt)
- [lint](https://developer.android.com/studio/write/lint)

#### Tests
- [Espresso](https://developer.android.com/training/testing/espresso/)
- [UiAutomator](https://developer.android.com/training/testing/ui-automator)

#### Continuous Integration
- [Travis CI](https://travis-ci.org)

#### Tools covered but removed:
- [Dagger 2](https://google.github.io/dagger/) (replaced by Koin)

---
### Feel free to use the code the way you prefer - Enjoy your studies!
---

## License
``` 
Copyright 2018 Igor Escodro

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
``` 
